." Text automatically generated by txt2man-1.4.8
.TH p3scan_readme  "January 6, 2006" ":version"
.SH DESCRIPTION
This is a fully transparent proxy-server for POP3, SMTP, and limited POP3S
Clients. It runs on a Linux box with iptables (for port re-direction).
.PP
It can be used to provide email scanning from/to the internet, to/from any
internal network and is ideal for helping to protect your "Other OS" LAN from
harm, especially when used synergically with a firewall and other Internet
Proxy servers.
.PP
It is designed to enable scanning of email messages for Viruses, Worms,
Trojans, Spam (read as "Un-solicited Bulk Email"), and harmfull attachments.
Because viewing HTML mail can enable a "Spammer" to validate an email address
(via web bugs), it can also provide dangerous HTML tag stripping.
.SH OVERVIEW
It works typically in situations where the linux box lies between the network
you wish to protect and the "outer world".
.PP
You have to set up a port redirection rule with iptables (see "IP-Tables / Port
redirecting") so that all connections from e.g. inside your office to any POP3,
POP3S, and SMTP server outside in the world will not leave your router, but come
to a local port, on which P3Scan listens.
.PP
P3Scan receives the original destination address of the "outer world" server
from the Linux kernel and connects to that address.
.PP
Anything received from the client will be sent to the server, and vice versa
but with a little enhancement: when a message is sent from the server it's
parsed, stored into a file, and scanned. If a virus is found a virus
notification is sent instead of the original infected message, which can be
quarantined or optionally deleted. If the message is destined for a server and
a virus is found, the client will be notified that the server rejected their
message due to a virus.
.PP
The message can also be scanned for spam, have potentially dangerous
attachments renamed, and have potentially malicious HTML parts
stripped. In the case of incoming messages, this is performed in the following order:

.nf
.fam C
Attachments are scanned/renamed/deleted (optional)
The message is scanned for virus's
The message is scanned for SPAM (optional)
The message is parsed for web bugs (optional)
.fam T
.fi
.PP
It should be possible to use any virus scanner using the scannertype=basic
configuration option. Known to work with this scanner are FRISK F-Prot and
Clam Anti Virus scanners.
.PP
P3Scan provides other scannertype's for scanning using Kaspersky, Trophie,
Clam (TCP) Anti-Virus Daemon's and also a bash script. Any C programmer can
easily adapt p3scan for other scan-daemons.
.PP
Neither the client nor the server has to be configured. None of them will ever
notice that there's a mail scanner. From the server point of view the incoming
connections are from the linux box IP. From the client point of view the only
evidence of the presence of p3scan are virus notifications and some additional
X-headers.
.SH REQUIREMENTS
.nf
.fam C
iptables - Normally installed by default on major Linux Distributions.
   http://www.netfilter.org
libpcre - Normally installed by default on major Linux Distributions.
   http://www.pcre.org
ripmime - Needed if your virus scanner does not support email.
   http://www.pldaniels.com/ripmime/
An Anti-Virus program
   P3Scan is known to work with:
      Kaspersky Anti-Virus for Linux (AVPD)
         http://www.kaspersky.com/
      Trophie Anti-Virus Daemon
         http://www.vanja.com/tools/trophie/
      FRISK F-Prot Antivirus
         http://www.f-prot.com/
      Clam Anti-Virus
         http://www.clamav.net/
      F-Secure Anti-Virus
         http://www.f-secure.com/
   Any other virus scanner that can output it's report to the console (stdout) so that it can be captured with "2>&1".
DSPAM (optional) - http://www.nuclearelephant.com/projects/dspam/
Mail::SpamAssassin (optional) - http://www.spamassassin.org
renattach (optional) - http://www.pc-tools.net/unix/renattach/
p3pmail (optional) - http://p3scan.sourceforge.net/#p3pmail
.fam T
.fi
.PP
Kernel:
The following kernel-parameters have to be enabled to get P3Scan to work normally.
This can be bypassed by using the "useurl" option of p3scan.conf.

If you have no clue about kernel-compiling, then here is some good news:
Most of Linux Distributions (with kernel 2.4.x or greater) support what
we need by default. However, if your distribution does not have it, please
read your system documentation on how to add it to your kernel.
.PP
.nf
.fam C
   -CONFIG_NETFILTER=y
   -CONFIG_IP_NF_IPTABLES=[y/m]
   -CONFIG_IP_NF_TARGET_REDIRECT=[y/m]

.fam T
.fi
.SH COMPILATION

Change to the directory where you untar'ed the program.
./configure --help to see compile options 
Once you decide which options to enable/disables, run
./configure <options> or ./configure by itself for the defaults.
then as user:
make
and as root (su root)
make install
.PP
The only binary will be copied to :bindir/p3scan.
.PP
Make install will also copy p3scan.conf, p3scan.conf.sample, p3scan.blacklist, p3scan.whitelist, and the p3scan-*.mail files into
:sysconfdir/p3scan while creating directories :sysconfdir/p3scan, :localstatedir/run/p3scan,
:localstatedir/spool/p3scan, :localstatedir/spool/p3scan/children, and :localstatedir/spool/p3scan/notify.
.PP
After this, you must prepare your configuration file as described below.
.PP
Preparing / Manual Configuration:
.PP
If you decide not to use "make install" (for example, you don't want gcc on
your firewall machine where p3scan is going to run). Please ensure the
following directories are created and that they are owned and
readable/writable by only the user "mail" (default).
.PP
.nf
.fam C
As root, create the following directories:
# mkdir :sysconfdir/p3scan
# mkdir :localstatedir/run/p3scan
# mkdir -p :localstatedir/spool/p3scan/children
# mkdir -p :localstatedir/spool/p3scan/notify

Make them "owned" by the user ":P3USER" (default):
# chown :P3USER::P3USER :sysconfdir/p3scan
# chown :P3USER::P3USER :localstatedir/run/p3scan
# chown -R :P3USER::P3USER :localstatedir/spool/p3scan

Then make them read/write by only our user:
# chmod 755 :sysconfdir/p3scan
# chmod 700 :localstatedir/run/p3scan
# chmod -R 700 :localstatedir/spool/p3scan

.fam T
.fi
If you don't have the user ":P3USER" and do not know how to create this user,
please see your operating systems documentation on how to create a user.
.PP
If you use any special character (like German-umlauts ) in your mail
template file, don't forget to set the charset to "utf8" (charset="utf8" vice
charset="iso-8859-1").
.SH CONFIGURATION

The configuration file defaults to :sysconfdir/p3scan/p3scan.conf
.PP
This file is a mixture of configuration data and documentation and MUST be
modified to work correctly upon initial installation. You must specify
AT LEAST how to call your anti-virus program and how to extract the virus
name (if one is found).
.PP
The purpose of p3scan is to provide virus protection to an internal network.
So, not having a virus scanner is not an option. That being said, if you still
do not want a virus scanner enabled, you can just set the scannertype/scanner
to basic/"/usr/bin/cat".
.PP
Currently, the default configuration is as follows (see p3scan.conf for more
info):
.PP
.nf
.fam C
  We DO NOT have an Anti-Virus program selected, scanner return code, nor
  regular expression on how to extract a virus name (if needed).
    scannertype=basic
    "scanner" is not set
    "viruscode" is not set
    "virusregexp" is not set
  Listening on 0.0.0.0:8110
  Run as user: :P3USER
  p3scan.conf: :sysconfdir/p3scan.conf
  logopt: 3
  logfac: 24
  debug: disabled
  * Note: The recommended debug procedure is to call p3scan as such:
    p3scan -d > debug 2>&1
    You can then keep track of the debug messages on another terminal
    with: tail -n 50 -f debug
  debug-memory: disabled
  debug-message: disabled
  debug-scanning: disabled
  debug-smtp: disabled
  demime: disabled
  We listen to any address: ip: 0.0.0.0
  The maximum simultaneous scans is: maxchilds: 10
  We listen only on: port: 8110
  We report all program steps to syslog less debug info. "quiet" is not set.
  Target ip/port not enabled
  We default to storing infected messages in: virusdir: :localstatedir/spool/p3scan
  The PID file is stored in: pidfile = :localstatedir/run/p3scan/p3scan.pid
  We create notification mails in: notifydir = :localstatedir/spool/p3scan/notify
  We keep infected mail: delete is disabled
  We look for at least 10MB of diskspace: freespace = 10000
  We DO NOT send entire lines of email header while processing to keep the
    email client "alive". We send characters instead. "broken" is not set.
  We DO NOT check for "Spam". checkspam: disabled
  We DO NOT rename attachments. "renattach" is not pointing to any external program.
  The Virus Report template defaults to: :sysconfdir/p3scan/p3scan-en.mail
  We generate the Virus Report Subject line as:
    "[Virus] found in a mail to you:" <virus name>
    you can change this with the "subject" line in p3scan.conf.
  We generate the Virus Report file disposition line (when delete is set):
    notify: Per instruction, the message has been deleted.
  The port for SMTP submissions is emailport = 25
  If an outgoing virus is detected, the SMTP reject message is:
    smtprset: Virus detected! P3scan rejected message!
  The port for SSL messages is sslport = 995
  The mail program used for sending alternate and extra mail is mail = /bin/mail
  The time between sending characters/lines to keep a client from timing out is
    timeout = 30
  We do not generate Virus Definition data for outgoing/notification messages.
    "footer" is not set.
  There is no alternate virus notification message in use. altvnmsg: disabled
  We use iptables for port redirection and do not get our destination ip/port
    via the incoming connection. useurl: disabled
  We do not allow any child process to terminate out main program in the event
    of error. "cleankill" is not set.
  We notify only the email client when a virus is detected: extra is disabled
  PIPELINING processing disabled
  STLS processing disabled

.fam T
.fi
IP-Tables / Port redirecting:
.PP
.nf
.fam C
   Rules like:
iptables -t nat -I PREROUTING -p tcp -i eth0 --dport pop3  -j REDIRECT --to 8110
iptables -t nat -I PREROUTING -p tcp -i eth0 --dport smtp -j REDIRECT --to 8110
iptables -t nat -I PREROUTING -p tcp -i eth0 --dport pop3s -j REDIRECT --to 8110
iptables -t nat -I OUTPUT  -p tcp --dport pop3 -j REDIRECT --to 8110
iptables -t nat -I OUTPUT  -p tcp --dport pop3 -m owner --uid-owner :P3USER -j ACCEPT
.fam T
.fi
.PP
.nf
.fam C
   are enough. Change eth0 to your device for the inbound connections (your
   office or home network).

   Also, "pop3", "smtp", and/or "pop3s" must be defined in your "services" file.
   Normally located at: /etc/services.

   If it is not defined, enter the definition you have for 110/tcp. IE: pop-3, or
   just enter the port number(s). IE: 110, 25, or 995

.fam T
.fi
Spam Checking
.PP
.nf
.fam C
   The spam checking capability of p3scan has only been tested using
   DSPAM >= 3.0.0-rc2 and Mail::SpamAssassin v2.6 >= v3.0.1

   If using dspam, you need to install the program according to the
   documentation found at http://www.nuclearelephant.com/projects/dspam/

   The recommended procedure is the virtual-users interface of the mysql
   driver.

   If you will be scanning for spam using SpamAssassin, you need to install the
   program according to the documentation found at http://www.spamassassin.org

   The easiest (as fastest) interface to Mail::SpamAssassin is through it's
   daemon program "spamd" using "spamc".

   You can start spamd as follows before running p3scan:
   *Note: This example is for using SpamAssassin w/mysql
   /usr/bin/spamd -d -u spamd -x -q &

.fam T
.fi
SSL Message parsing:
.PP
.nf
.fam C
   We are able to perform limited checking of messages using SSL.
   To use this feature, you must tell your email client NOT to use SSL and just
   change the pop3 port from 110 to 995. If p3scan sees a destination port of 995
   (or whatever port "sslport" is set to) it will initiate an SSL conversation.

   NOTE: This is limited support as p3scan will not show you the SSL certificate
   and will just accept any certificate as sent by the actual server.

.fam T
.fi
renattach:
Is used to rename attachments and is totally configurable.
.RS
.PP
Renattach must be compiled, installed, and configured before enabling this
feature. See the renattach documentation INSTALL and README for further
information.
.RE
.PP
HTML Parsing:
The HTML parsing option is now an external program to p3scan. This
facilitates using any program you can find. I have written a separate
program for this function called p3pmail which can be found on the p3scan
web site.
.RS
.PP
P3PMail will obfuscate the tags "href" and "src" the two most dangerous
HTML tags (IMHO) for email. Of course, if your using a non-html email
client, you will not have to worry about "web-bugs".
.RE
.PP
Startup:
Call p3scan without any parameters, it will move into the background.
You can monitor it's operation via your systems log file.
You should also test your installation by sending yourself an eicar test
virus (which will not damage your system). You can get versions of this
file at http://www.eicar.org/anti_virus_test_file.htm
.RS
.PP
If you think too much information is being sent to your system logs, you
can enable the "quiet" option. This will inhibit "normal" messages.
.PP
If p3scan is started by root, it will change it's user to :P3USER (default)
after it finishes it's initial startup.
.PP
If you are using Mail::SpamAssassin, start spamd BEFORE running p3scan.
.RE
.PP
RC System / Boot up:
"make install" should determine the correct p3scan startup file and place it
in the proper directory.
.RS
.PP
If for some reason this does not happen, you can add p3scan to your normal
default startup file. For example, in Slackware place p3scan as follows:
.PP
# echo :bindir/p3scan >> /etc/rc.d/rc.local
.PP
and please notify the p3scan-main mailing list of this problem.
.RE
.RE
.PP

.SH SEE ALSO
"p3scan" ":sysconfdir/p3scan/p3scan.conf"
.PP
BUGS/SUPPORT
Please report any bugs to the p3scan support mailing list accessable through:
http://sourceforge.net/projects/p3scan
.SH AUTHORS
Jack S. Lai <laitcg at cox dot net>
and contributers (see CONTRIBUTERS file).
